{*******************************************************************}
{Verze 2.2  3.8.2005}
{*******************************************************************}
program Ser_Log;
{$M 6000,0,0 }
uses dos,fdelay,crtp2; {crt,fdelay,crtp2}

var
ISR_Save_COM1,ISR_Save_COM2 :Pointer;

Znak: byte;

Adr_COM1,Adr_COM2:word;

Code,Pom:integer;

COM1_Bufer,COM2_Bufer:array [0..1023] of byte;
Ukaz_COM1_In,Ukaz_COM2_In:word;
Ukaz_COM1_Out,Ukaz_COM2_Out:word;

Soubor1:text;
Soubor2:text;

Radek_COM1,Radek_COM2,Prevod,Jmeno:string;

Rok,Mesic,Den,Dt : Word;
Hod,Min,Sec,Sto  : Word;
Pocet_B_COM1,Pocet_B_COM2:longint;
Pocet_P_COM1,Pocet_P_COM2:byte;

Pocet_Pipnuti:byte;

const
K_POCET_BYTE:byte=75;

SBUF:byte=0 ;    {DATA+dli}
IER :byte=1 ;    {Aktivace peruen}
IIR :byte=2 ;    {Identifikace int}
LCR :byte=3 ;    {Nastaven linky}
MCR :byte=4 ;    {Nastaven modemu}
LSR :byte=5 ;    {Stav linky}
MSR :byte=6 ;    {Stav modemu}
SCR :byte=7 ;    {RAM 1 byt}
{*******************************************************************}
{*******************************************************************}
procedure ISR_COM1;
interrupt;

var
Pom_COM1,Status_COM1:byte;
begin

repeat
	begin
		Status_COM1:=Port[Adr_COM1+IIR] and 15;

        case Status_COM1 of
    	  6:
			begin
				Pom_COM1:=Port[Adr_COM1+LSR]; {Pest chybu- vymae IIR}
		       	Pom_COM1:=Port[Adr_COM1+SBUF]; {Pest vadn byt}
		    end;
          4,12:
          	begin
	    		while (Port[Adr_COM1+LSR] and 1)=1 do
					begin
		        		if (Ukaz_COM1_In+1) <> Ukaz_COM1_Out then
			        		begin
		   	         			Inc(Ukaz_COM1_In);
		   	             		if Ukaz_COM1_In>1023 then Ukaz_COM1_In:=0;
		   	            		COM1_Bufer[Ukaz_COM1_In]:=Port[Adr_COM1+SBUF];
		   	        	end;
		   	 		end;
		    end;
          0: Pom_COM1:=Port[Adr_COM1+MSR];
          end;
    end;

until Status_COM1=1;

Port[$20]:=$20;
end;
{*******************************************************************}
procedure ISR_COM2;
interrupt;

var
Pom_COM2,Status_COM2:byte;
begin

repeat
	begin
		Status_COM2:=Port[Adr_COM2+IIR] and 15;

        case Status_COM2 of
    	  6:
			begin
				Pom_COM2:=Port[Adr_COM2+LSR]; {Pest chybu- vymae IIR}
		       	Pom_COM2:=Port[Adr_COM2+SBUF]; {Pest vadn byt}
		    end;
          4,12:
          	begin
	    		while (Port[Adr_COM2+LSR] and 1)=1 do
					begin
		        		if (Ukaz_COM2_In+1) <> Ukaz_COM2_Out then
			        		begin
		   	         			Inc(Ukaz_COM2_In);
		   	             		if Ukaz_COM2_In>1023 then Ukaz_COM2_In:=0;
		   	            		COM2_Bufer[Ukaz_COM2_In]:=Port[Adr_COM2+SBUF];
		   	        	end;
		   	 		end;
		    end;
          0: Pom_COM2:=Port[Adr_COM2+MSR];
          end;
    end;

until Status_COM2=1;

Port[$20]:=$20;
end;
{*******************************************************************}
procedure Ini_Portu (Adresa_Portu:word);
begin
	port[Adresa_Portu+IER]:=0 ;  {dn peruen}


	port[Adresa_Portu+LCR]:=$80   ;   {DLAB=1}

	port[Adresa_Portu+0]:=12   ;
	port[Adresa_Portu+1]:=0   ; {9600 Bd delitel}
{0x01 = 115,200 BPS
 0x03 = 38,400 BPS
 0x02 = 56,700 BPS
 0x06 = 19,200 BPS
 0x0C = 9,600 BPS
 0x18 = 4,800 BPS
 0x30 = 2,400 BPS}


	port[Adresa_Portu+LCR]:=$03 ; {DLAB=0 8,1,N}

	port[Adresa_Portu+IIR]:=$83 ; {FIFO 12B trig, clear bufer}
    if (port[Adresa_Portu+IIR] and $C0)<>$C0 then
    	begin
			port[Adresa_Portu+IIR]:=0 ; {FIFO nejde!!}
        end;

	port[Adresa_Portu+IER]:=5   ; {peruen - pjem a timeout + chyby}
	port[Adresa_Portu+MCR]:=$0A ; {0A DTR, aktivn RTS aktivn OUT2 aktivn}

    Sound(1000);
	Delay(200);
	NoSound;
    delay(150);
    Sound(1800);
	Delay(200);
	NoSound;
    delay(150);
    Sound(1000);
	Delay(200);
	NoSound;

end;
{*******************************************************************}
procedure Vyp_Portu (Adresa_Portu:word);
begin
	port[Adresa_Portu+IER]:=0 ;  {dn peruen}
	port[Adresa_Portu+IIR]:=$00 ; {FIFO 12B trig, clear bufer}

	port[Adresa_Portu+IER]:=0;
	port[Adresa_Portu+MCR]:=0;
end;
{*******************************************************************}
{Tady se prevede polozka datumu/asu na string}

function Preved_Cislo(Cislo:word):String;
var
Pom_Prev:string;
begin;
	str(Cislo,Pom_Prev);
    if Cislo<10 then Pom_Prev:='0'+Pom_Prev;
	Preved_Cislo:=Pom_Prev;
end;
{*******************************************************************}
{Tady se prevede sla v A na ASCI i Hexa znaky}

function Hex_Dec(Cislo:word):String;
begin;
	if Cislo<9 then
     begin
   		Cislo:=Cislo+48
     end else begin
   		Cislo:=Cislo+55
     end;
	Hex_Dec:=char(Cislo);
end;
{*******************************************************************}
{Tady se inicializuje soubor}

procedure Zaloz_Soubor1;
var
Prevod,Jmeno:string;

begin;

GetDate(rok,mesic,den,dt);
GetTime(hod,min,sec,sto);

Jmeno:='A'+Hex_Dec(Mesic);
Jmeno:=Jmeno+Preved_Cislo(Den);
Jmeno:=Jmeno+Preved_Cislo(Hod);;
Jmeno:=Jmeno+Preved_Cislo(Min);;

assign(Soubor1,Jmeno+'.txt');
end;

{*******************************************************************}
{Tady se inicializuje soubor}

procedure Zaloz_Soubor2;

begin;

GetDate(rok,mesic,den,dt);
GetTime(hod,min,sec,sto);

Jmeno:='B'+Hex_Dec(Mesic);
Jmeno:=Jmeno+Preved_Cislo(Den);
Jmeno:=Jmeno+Preved_Cislo(Hod);;
Jmeno:=Jmeno+Preved_Cislo(Min);;

assign(Soubor2,Jmeno+'.txt');

end;
{*******************************************************************}
{*******************************************************************}
{*******************************************************************


   T a d y   t o   z a   n 


********************************************************************}
{*******************************************************************}
{*******************************************************************}
begin;

clrscr;
if ((ParamStr(1)='/?') or (ParamStr(1)='')) then
             begin
	            writeln ('Napoveda: ser_log.exe 1 - pipnuti 10x,');
	            writeln ('          ser_log.exe 0 - pipnuti pokazde');
             end;
if (ParamStr(1)='0') then Pocet_Pipnuti:=0 else Pocet_Pipnuti:=1;

{COM1}
Adr_COM1:=$3F8;
GetIntVec($0C,ISR_Save_COM1);
SetIntVec($0C,Addr(ISR_COM1));
Port[$21]:=(Port[$21] and $EF);

Ini_Portu(Adr_COM1);
Pocet_P_COM1:=10;

{COM2}
Adr_COM2:=$2F8;
GetIntVec($0B,ISR_Save_COM2);
SetIntVec($0B,Addr(ISR_COM2));
Port[$21]:=(Port[$21] and $F7);

Ini_Portu(Adr_COM2);
Pocet_P_COM2:=10;


Zaloz_Soubor1;
rewrite(Soubor1);
Zaloz_Soubor2;
rewrite(Soubor2);
Radek_COM1:='';
Radek_COM2:='';
{*******************************************************************}
repeat
{ if (Port[Adr_COM1+IIR] and 15)<>1 then ISR_COM1;}

 if Ukaz_COM1_In <> Ukaz_COM1_Out then
 	begin
    	Inc(Ukaz_COM1_Out);
        if Ukaz_COM1_Out=1024 then Ukaz_COM1_Out:=0;

 		if COM1_Bufer[Ukaz_COM1_Out]=13 then
	       	begin
       	    	GetDate(rok,mesic,den,dt);
				GetTime(hod,min,sec,sto);

				str(Rok,Jmeno);
				Jmeno:=Jmeno+'.'+Preved_Cislo(Mesic)+'.';
				Jmeno:=Jmeno+Preved_Cislo(Den)+' ';
				Jmeno:=Jmeno+Preved_Cislo(Hod)+':';;
				Jmeno:=Jmeno+Preved_Cislo(Min)+':';
				Jmeno:=Jmeno+Preved_Cislo(Sec);
               	write(Soubor1,' ');
               	writeln(Soubor1,Jmeno);
                writeln(Radek_COM1+' '+Jmeno);

   	            Radek_COM1:='';
       	        flush(Soubor1);

				if (Pocet_P_COM1<>0) then
					begin
					    Sound(1600);
						Delay(200);
						NoSound;
                        Pocet_P_COM1:=Pocet_P_COM1-Pocet_Pipnuti;
                    end;

   	            Pocet_B_COM1:=Pocet_B_COM1+19;

       	        if (Pocet_B_COM1>500000) then
           	    	begin
               	    	close(Soubor1);
                   	    Zaloz_Soubor1;
                       	Rewrite(Soubor1);

                        Pocet_B_COM1:=0;
               		end;
            end
        	else
            	begin
		    	    write(soubor1,char(COM1_Bufer[Ukaz_COM1_Out]));
			        Radek_COM1:=Radek_COM1+(char(COM1_Bufer[Ukaz_COM1_Out]));
            end;
        inc(Pocet_B_COM1);
 	end;

 {*******************************************************************}
 {COM2}

 if Ukaz_COM2_In <> Ukaz_COM2_Out then
 	begin
    	Inc(Ukaz_COM2_Out);
        if Ukaz_COM2_Out=1024 then Ukaz_COM2_Out:=0;

 		if COM2_Bufer[Ukaz_COM2_Out]=13 then
	       	begin
       	    	GetDate(rok,mesic,den,dt);
				GetTime(hod,min,sec,sto);

				str(Rok,Jmeno);
				Jmeno:=Jmeno+'.'+Preved_Cislo(Mesic)+'.';
				Jmeno:=Jmeno+Preved_Cislo(Den)+' ';
				Jmeno:=Jmeno+Preved_Cislo(Hod)+':';;
				Jmeno:=Jmeno+Preved_Cislo(Min)+':';
				Jmeno:=Jmeno+Preved_Cislo(Sec);
               	write(Soubor2,' ');
               	writeln(Soubor2,Jmeno);
                writeln(Radek_COM2+' '+Jmeno);

   	            Radek_COM2:='';
       	        flush(Soubor2);

				if (Pocet_P_COM2<>0) then
					begin
					    Sound(800);
						Delay(200);
						NoSound;

                        Pocet_P_COM2:=Pocet_P_COM2-Pocet_Pipnuti;
                    end;

   	            Pocet_B_COM2:=Pocet_B_COM2+19;

       	        if (Pocet_B_COM2>500000) then
            	   	begin
                    	close(Soubor2);
                 	    Zaloz_Soubor2;
                       	Rewrite(Soubor2);

                        Pocet_B_COM2:=0;
                	end;
            end
        else
           	begin
		   	    write(soubor2,char(COM2_Bufer[Ukaz_COM2_Out]));
		        Radek_COM2:=Radek_COM2+(char(COM2_Bufer[Ukaz_COM2_Out]));
            end;
       	inc(Pocet_B_COM2);
 	end;


until KeyPressed;
{*******************************************************************}
{Konec uloit systemov parametry
a zakzet peruen}

{COM1 (IRQ4) - 0x10
 COM2 (IRQ3) - 0x08
 COM3 (IRQ4) - 0x10
 COM4 (IRQ3) - 0x08}

{COM1}
Port[$21]:=(Port[$21] or $10);
SetIntVec($0C,Addr(ISR_COM1));
Vyp_Portu(Adr_COM1);


{COM2}
Port[$21]:=(Port[$21] or $08);
SetIntVec($0C,ISR_Save_COM2);
Vyp_Portu(Adr_COM2);

end.




